unit U_CityDlg;
 {Copyright 2002, Gary Darby, Intellitech Systems Inc., www.DelphiForFun.org

 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved
 }
interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, ExtCtrls, Forms;

type
  TCityDlg = class(TForm)
    AddUpdtBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    NameEdt: TEdit;
    DeleteBtn: TButton;
    procedure AddUpdtBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  end;

var
  CityDlg: TCityDlg;

implementation

{$R *.DFM}

Uses U_TSP;

procedure TCityDlg.AddUpdtBtnClick(Sender: TObject);
begin
  with form1, citylist do
  begin
    coordobj.cityname:=nameedt.text;
    if newflag then
    begin {new city}
      index:=add(key);
      objects[index]:=coordobj;
      showcity(coordobj);
    end
    else {update}
    begin
      {nothing to do?}
    end;
    Savelist;
  end;
end;

procedure TCityDlg.CancelBtnClick(Sender: TObject);
begin
  if not form1.newflag then
  with form1 do
  begin
    coordobj.cityname:=oldname;
    coordobj.x:=oldx;
    coordobj.y:=oldy;
  end;
end;

procedure TCityDlg.DeleteBtnClick(Sender: TObject);
begin
  If not form1.newflag then
  with form1, citylist do
  begin
    coordobj.free;
    delete(index);
    SaveList;
    image1.canvas.stretchdraw(rect(0,0,image1.width,image1.height),bitmap);
    showcities(Citylist);
  end;
end;

procedure TCityDlg.FormActivate(Sender: TObject);
begin
  NameEdt.setfocus;  {make sure edit field is initially selected}
end;

end.
